<template>
    <div :id="`${ table }-list`">
        <ul v-if="link" class="list-group">
            <router-link v-for="(match, index) in matches" :key="index" :to="destination(match.id)">
                <li class="list-group-item">
                    <h4>{{ match.name }}<small v-if="isDifferentiable(match)"> {{ differentiate(match) }}</small></h4>
                </li>
            </router-link>
        </ul>
        <ul v-if="!link" class="list-group">
            <a v-for="(match, index) in matches" :key="index" @mousedown="$emit('select:match', match)">
                <li class="list-group-item">
                    <h4 v-if="!isWorks">{{ match.name }}<small v-if="isDifferentiable(match)"> {{ differentiate(match) }}</small></h4>
                    <h4 v-else>{{ match.job }}, {{ match.title }}</h4>
                </li>
            </a>
        </ul>
    </div>
</template>

<script>
    export default {
        name: "list",
        props: {
            matches: {
                type: Array,
                required: true,
            },
            link: {
                type: Boolean,
                default: false,
            },
            table: {
                type: String,
                required: true,
            },
        },
        computed: {
            isPeople() {
                return this.table === 'people'
            },
            isEntertainment() {
                return this.table === 'entertainment'
            },
            isWorks() {
                return this.table === 'works'
            },
        },
        methods: {
            destination(id) {
                return `/${ this.table }/${ id }`;
            },
            differentiate(match) {
                if (this.isPeople) {
                    return `(${match.job}, ${match.title})`
                } else if (this.isEntertainment) {
                    return `(${match.released}${match.ended ? `-${match.ended}` : ''} ${match.type})`
                }
            },
            isDifferentiable(match) {
                return this.isPeople && match.known_for !== null || this.isEntertainment;
            },
        }
    }
</script>

<style scoped>
    ul a {
        text-decoration: none;
        color: black;
    }

    ul a:hover {
        color: darkgrey;
    }

    ul a:active {
        color: dimgrey;
    }

    /*ul {
        position: absolute;
    }*/

    ul li {
        cursor: pointer;
    }
</style>